from tkinter import *
import random
def array(N1, N2=0,N3=0):   #■配列宣言
    if N2==0: return [0 for i in range(N1)]
    if N3==0: return [[0 for i in range(N2)]
                      for j in range(N1)]
    return[[[0 for i in range(N3)]for j in range(N2)]
           for j in range(N1)]
MapDT=array(2,100,100)
def dispFrame(canvas):      #■分布図の枠を描く
    canvas.create_line( 38,302, 38,100,fill="gray")
    canvas.create_line(240,302,240,100,fill="gray")
    canvas.create_line( 38,302,240,302,fill="gray")
    canvas.create_line( 38,100,240,100,fill="gray")
def dispMap(canvas,A):      #■元データ表示
    CL=["#FF0000","#00FF00","#0000FF"]
    for i in range(len(A)):
        X=A[i][0]*2+40;Y=300-A[i][1]*2;ID=A[i][2]-1
        canvas.create_oval(X-2,Y-2,X+2,Y+2,fill=CL[ID])
def drawBoundary(canvas, ID):#■境界線の表示
    global MapDT; CL="#0000FF"
    ID2=1-ID;MX=len(MapDT[0]);MY=len(MapDT[0][0])
    for i in range(0,MX):
        X=i*2+40
        for j in range(1,MY):
            if MapDT[ID][i][j-1]!=MapDT[ID][i][j]:
                Y=300-j*2+2
                canvas.create_line(X-2,Y,X,Y,fill=CL)
    for j in range(0,MY):
        Y=300-j*2+2
        for i in range(1,MX):
            if MapDT[ID][i-1][j]!=MapDT[ID][i][j]:
                X=i*2+40-2
                canvas.create_line(X,Y-2,X,Y,fill=CL)

def genMap(canvas,MapDT):   #■初期表示(図形ID生成)
    CL=["#FFFFFF","#77FFFF","#FFFF77","#FF77FF"]
    MapID=array(100,100)
    for i in range(len(MapDT)):
        X=i*2+40
        for j in range(len(MapDT[0])):
            Y=300-j*2;ID=MapDT[i][j]
            MapID[i][j]=(canvas.create_rectangle
                         (X-2,Y-2,X+2,Y+2,
                          fill=CL[ID],outline=CL[ID]))
    return MapID
def dspMap(canvas,MapDT,MapID):#■表示変更
    CL=["#FFFFFF","#77FFFF","#FFFF77","#FF77FF"]
    for i in range(len(MapDT)):
        for j in range(len(MapDT[0])):
            ID=MapDT[i][j]
            canvas.itemconfig(MapID[i][j],
                              fill=CL[ID],outline=CL[ID])
def updateDT(ID):          #■データ変更
    global MapDT
    ID2=1-ID;MX=len(MapDT[0]);MY=len(MapDT[0][0])
    for i in range(MX):
        for j in range(MY):
            if MapDT[ID][i][j]!=0:
                V=MapDT[ID][i][j];MapDT[ID2][i][j]=V
                for k1 in range(-1,2):
                    ii=i+k1
                    if ii>=0 and ii<MX:
                        for k2 in range(-1,2):
                            jj=j+k2
                            if k1!=k2 and jj>=0 and jj<MY:
                                V2=MapDT[ID][ii][jj]
                                if V2==0:
                                    MapDT[ID2][ii][jj]=V
                                else:
                                    MapDT[ID2][ii][jj]=V2
    return ID2
def notEnd(ID):              #■処理終了の判定
    global MapDT
    ID2=1-ID;MX=len(MapDT[0]);MY=len(MapDT[0][0])
    for i in range(MX):
        for j in range(MY):
            if MapDT[ID][i][j]==0:return True
    return False
def execClass(root,canvas):
    ID=0;count=0
    MapID=genMap(canvas,MapDT[ID])
    while notEnd(ID):
        count+=1
        ID=updateDT(ID)
        dspMap(canvas,MapDT[ID],MapID)
        root.update()
    drawBoundary(canvas, ID)
    return count
